<!DOCTYPE html>
<html lang="en">
<head>
	<meta charset="UTF-8">
	<meta name="viewport" content="width=device-width, initial-scale=1.0">
	<meta http-equiv="Cache-Control" content="no-cache, no-store, must-revalidate">
	<meta http-equiv="Pragma" content="no-cache">
	<meta http-equiv="Expires" content="0">
	<title>Weilianqi</title>
	<link rel="stylesheet" href="../style.css">
</head>

<body>
<header>
<nav>
	<ul>
		<li><a href="/">Home</a></li>
		<li><a href="/play.html">Play</a></li>
		<li><a href="/articles.html">Articles</a></li>
	</ul>
</nav>
</header>
<main>
<h1>Implementing a migration for the rps chain</h1>

<p><small>Published 23/2/2022.</small></p>

<p>This is a continuation of the <a href="rps-chain.html">previous rps article</a>, to follow along either go through that one first or acquire <a href="https://gitlab.com/marcus.appelros/rps/-/tree/v0.1" target="_blank">v0.1 of the repository</a>. The plan now is to add a map where players can look up the games they are associated with.</p>

<p>Run the chain, start some games and finish a few of them, If you haven't already. Check the current block height with <code>rpsd q block</code> and stop the chain. Next make a backup of the ~/.rps folder.</p>

<p>Migrations are usually performed by passing a software upgrade proposal however we are going to take a shortcut and simply register the upgrade in the EndBlock hook. Open app/app.go in your favorite IDE (I use Atom for the obvious reason) and navigate to the EndBlocker function where you add the following, with the block heights adjusted appropriately:</p>
<pre class="prebox"><code>	if ctx.BlockHeight() == 59340 {
		plan := upgradetypes.Plan{Name: "add-playerMap", Height: 59350}
		app.UpgradeKeeper.ScheduleUpgrade(ctx, plan)
	}
</code></pre>

<p>Rebuild rpsd with <code>starport c build</code> and run the chain through <code>rpsd start</code> (or use <code>starport c serve --verbose</code>) until it halts and says the upgrade is needed, ctrl-C the chain and add our map with the following command: <code>starport scaffold map player ongoing:array.uint completed:array.uint --no-message</code></p>

<p>Then open x/rps/module.go at line 140 where the RegisterServices function is, within it add the following:</p>
<pre class="prebox"><code>	cfg.RegisterMigration(types.ModuleName, 1, func(ctx sdk.Context) error {
		// Perform in-place store migrations from ConsensusVersion 1 to 2.
		// Starport currently initiates the CV to 2 even though the Cosmos docs say it should start at 1.
		// The Cosmos docs also state that there has to be a migration for every preceding version, hence this dummy function.
		return nil
	})
	cfg.RegisterMigration(types.ModuleName, 2, func(ctx sdk.Context) error {
		// Perform in-place store migrations from ConsensusVersion 2 to 3.
		playerMap := make(map[string]*types.Player)
		k := am.keeper
		matches := k.GetAllMatch(ctx)
		for _, match := range matches {
			for _, addr := range []string{match.Player1, match.Player2} {
				player, found := playerMap[addr]
				if !found {
					player = &types.Player{
						Index:     addr,
						Ongoing:   []uint64{},
						Completed: []uint64{},
					}
				}
				if match.Winner > 0 {
					player.Completed = append(player.Completed, match.Id)
				} else {
					player.Ongoing = append(player.Ongoing, match.Id)
				}
				playerMap[addr] = player
			}
		}
		for _, player := range playerMap {
			k.SetPlayer(ctx, *player)
		}
		return nil
	})
</code></pre>

<p>The dummy migration from 1 to 2 is there because for some reason starport initializes modules to version 2, I have opened <a href="https://github.com/tendermint/starport/issues/2108" target="_blank">an issue on this matter</a>. While in the module.go file modify the ConsensusVersion function to return 3.</p>

<p>Go back to the app.go file and search for <code>app.mm.RegisterServices</code>. Notice that the configurator passed to RegisterServices, where the migrations are stored, is itself not saved anywhere. This is a problem as we need to access those migrations when performing the upgrade (<a href="https://github.com/tendermint/starport/issues/2115" target="_blank">I've submitted an issue on this as well</a>), to remedy the situation lift the NewConfigurator call out of the parenthesises and into a variable we will call appcfg:</p>
<pre class="prebox"><code>	appcfg = module.NewConfigurator(app.appCodec, app.MsgServiceRouter(), app.GRPCQueryRouter())
	app.mm.RegisterServices(appcfg)
</code></pre>

<p>Then declare it as a global variable for example on line 102:</p>
<pre class="prebox"><code>var appcfg module.Configurator
</code></pre>

<p>Finally search for the assigning of the apps UpgradeKeeper (<code>app.UpgradeKeeper = upgradekeeper.NewKeeper</code>) and below it insert:</p>
<pre class="prebox"><code>	app.UpgradeKeeper.SetUpgradeHandler("add-playerMap", func(ctx sdk.Context, plan upgradetypes.Plan, fromVM module.VersionMap) (module.VersionMap, error) {
		return app.mm.RunMigrations(ctx, appcfg, fromVM)
	})
</code></pre>

<p>Now the upgrade logic is complete and we just have to handle new games that are started and finished. Open x/rps/keeper/msg_server_join_queue.go and insert the following in a good place (get the id from <code>id := k.AppendMatch(ctx, match)</code>):</p>
<pre class="prebox"><code>		for _, addr := range []string{match.Player1, match.Player2} {
			player, found := k.GetPlayer(ctx, addr)
			if !found {
				player = types.Player{
					Index:     addr,
					Ongoing:   []uint64{},
					Completed: []uint64{},
				}
			}
			player.Ongoing = append(player.Ongoing, id)
			k.SetPlayer(ctx, player)
		}
</code></pre>

<p>Next open x/rps/keeper/msg_server_submit_move.go and find a fitting location for the following:</p>
<pre class="prebox"><code>		for _, addr := range []string{match.Player1, match.Player2} {
			player, found := k.GetPlayer(ctx, addr)
			if !found {
				panic("Player not found even though they finished a match.")
			}
			for i, mid := range player.Ongoing {
				if mid == match.Id {
					player.Ongoing = append(player.Ongoing[:i], player.Ongoing[i+1:]...)
					break
				}
			}
			player.Completed = append(player.Completed, match.Id)
			k.SetPlayer(ctx, player)
		}
</code></pre>

<p>Perfect! Now rebuild the chain, launch with <code>rpsd start</code> and verify that the map of players got populated with <code>rpsd q rps list-player</code></p>

<p>Note that I had some very strange corruption issues when using <code>starport c serve</code> above instead of <code>rpsd start</code>, debug messages got printed in the exported genesis and when I restored the ~/.starport/local-chains/rps backup it flat out refused to start even after <code>c serve -r</code> with errors like <code>panic: parameter UnbondingTime not registered</code> and <code>ERR CONSENSUS FAILURE!!! err="parameter HistoricalEntries not registered"</code>. In addition it didn't execute the migration. Even though the migration went fine when using the daemon directly when I afterwards tried to pick up with <code>c serve</code> it could not read the database and on shutdown gave a <code>panic: UnmarshalJSON cannot decode empty bytes</code>, running the chain with starport after the upgrade corrupted something as <code>rpsd start</code> could not resume afterwards.</p>

<p>Output of <code>starport version</code>:</p>
<pre class="prebox"><code>Starport version:	v0.19.1
Starport build date:	2021-12-18T05:56:36Z
Starport source hash:	-
Your OS:		linux
Your arch:		amd64
Your go version:	go version go1.16.2 linux/amd64
</code></pre>

<p>To learn how to build a frontend for the chain see <a href="rps-frontend.html">the next article.</a></p>

<br><br><br><br><br><br><br>
</main>
<footer>
<nav>
	<ul>
		<li><a href="/">Home</a></li>
		<li><a href="/play.html">Play</a></li>
		<li><a href="/articles.html">Articles</a></li>
	</ul>
</nav>
</footer>
</body>

</html>
